/**
 * Legato is a configurable, lightweight web mapping client that can be
 * easily embedded into web pages and portals, CMS and individual web
 * applications. Legato is implemented in JavaScript and based on the
 * popular open source library OpenLayers.
 *
 * Copyright (C) 2010  disy Informationssysteme GmbH, http://www.disy.net
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.disy.legato.testing.server.testing;

import junit.framework.Assert;

import net.disy.legato.testing.server.IWebServerEnvironment;
import net.disy.legato.testing.server.IWebServerEnvironmentFactory;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public abstract class AbstractWebServerEnvironmentTest {

  public abstract String getPropertiesFileName();

  protected IWebServerEnvironment webServerEnvironment;

  public abstract IWebServerEnvironmentFactory getWebServerEnvironmentFactory() throws Exception;

  @Before
  public void start() throws Exception {
    final IWebServerEnvironmentFactory factory = getWebServerEnvironmentFactory();

    webServerEnvironment = factory.createWebServerEnvironment();

    webServerEnvironment.start();

  }

  @Test
  public void test() throws Exception {
    Assert.assertTrue(webServerEnvironment.isStarted());
  }

  @After
  public void stop() throws Exception {
    webServerEnvironment.stop();
  }
}
